Package ghidra.pcode.emu.jit.gen.tgt

# Record Class JitCompiledPassage.EntryPoint

java.lang.Object
java.lang.Record
ghidra.pcode.emu.jit.gen.tgt.JitCompiledPassage.EntryPoint

Record Components:
  `prototype` - the entry point prototype (passage class and blockId without bound thread)
  `passage` - the compiled passage, instantiated for the bound thread
  `blockId` - an index identifying the block at the target address and contextreg value of this entry point

Enclosing interface:
  `JitCompiledPassage`

public static record JitCompiledPassage.EntryPoint(JitCompiledPassage.EntryPointPrototype prototype, JitCompiledPassage passage, int blockId) extends Record
An entry point into a translated passage

This represents a translated passage and an index into its list of entry points. For an overview of how this fits into the JIT-accelerated execution loop, see `JitPcodeThread`, especially the Translate and Execute sections. For details of how the entry points and their metadata are exported, see `JitCodeGenerator`, especially the Entry Point Dispatch section.

- ## Constructor Summary

  Constructors
  Constructor
  Description
  `EntryPoint(JitCompiledPassage.EntryPointPrototype prototype, JitCompiledPassage passage, int blockId)`
  Creates an instance of a `EntryPoint` record class.

- ## Method Summary

  Modifier and Type
  Method
  Description
  `int`
  `blockId()`
  Returns the value of the `blockId` record component.
  `final boolean`
  `equals(Object o)`
  Indicates whether some other object is "equal to" this one.
  `final int`
  `hashCode()`
  Returns a hash code value for this object.
  `JitCompiledPassage`
  `passage()`
  Returns the value of the `passage` record component.
  `JitCompiledPassage.EntryPointPrototype`
  `prototype()`
  Returns the value of the `prototype` record component.
  `JitCompiledPassage.EntryPoint`
  `run()`
  Start/resume execution of the bound thread at this entry point.
  `final String`
  `toString()`
  Returns a string representation of this record class.

  ### Methods inherited from class java.lang.Object

  `clone, finalize, getClass, notify, notifyAll, wait, wait, wait`

- ## Constructor Details

  - ### EntryPoint

    public EntryPoint(JitCompiledPassage.EntryPointPrototype prototype, JitCompiledPassage passage, int blockId)
    Creates an instance of a `EntryPoint` record class.
    Parameters:
      `prototype` - the value for the `prototype` record component
      `passage` - the value for the `passage` record component
      `blockId` - the value for the `blockId` record component

- ## Method Details

  - ### run

    public JitCompiledPassage.EntryPoint run()
    Start/resume execution of the bound thread at this entry point.

    The associated passage is invoked, starting at the given block via `JitCompiledPassage.run(int)`, which was generated by `JitCodeGenerator`.

    Returns:
      as in `JitCompiledPassage.run(int)`

  - ### toString

    public final String toString()
    Returns a string representation of this record class. The representation contains the name of the class, followed by the name and value of each of the record components.
    Specified by:
      `toString` in class `Record`
    Returns:
      a string representation of this object

  - ### hashCode

    public final int hashCode()
    Returns a hash code value for this object. The value is derived from the hash code of each of the record components.
    Specified by:
      `hashCode` in class `Record`
    Returns:
      a hash code value for this object

  - ### equals

    public final boolean equals(Object o)
    Indicates whether some other object is "equal to" this one. The objects are equal if the other object is of the same class and if all the record components are equal. Reference components are compared with `Objects::equals(Object,Object)`; primitive components are compared with '=='.
    Specified by:
      `equals` in class `Record`
    Parameters:
      `o` - the object with which to compare
    Returns:
      `true` if this object is the same as the `o` argument; `false` otherwise.

  - ### prototype

    public JitCompiledPassage.EntryPointPrototype prototype()
    Returns the value of the `prototype` record component.
    Returns:
      the value of the `prototype` record component

  - ### passage

    public JitCompiledPassage passage()
    Returns the value of the `passage` record component.
    Returns:
      the value of the `passage` record component

  - ### blockId

    public int blockId()
    Returns the value of the `blockId` record component.
    Returns:
      the value of the `blockId` record component